Make sure that config.h.in is up-to-date before allowing the
[rsync/rsync.git] / runtests.sh
CommitLineData
e7d29902
MP
1#! /bin/sh
2
cf72f204 3# Copyright (C) 2001, 2002 by Martin Pool <mbp@samba.org>
0f78b815 4# Copyright (C) 2003, 2004, 2005, 2006 Wayne Davison
e7d29902
MP
5
6# This program is free software; you can redistribute it and/or modify
a4cf6bec
MP
7# it under the terms of the GNU General Public License version
8# 2 as published by the Free Software Foundation.
e7d29902
MP
9#
10# This program is distributed in the hope that it will be useful, but
11# WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
13# Lesser General Public License for more details.
14#
15# You should have received a copy of the GNU Lesser General Public
16# License along with this program; if not, write to the Free Software
0f78b815 17# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
e7d29902
MP
18
19# rsync top-level test script -- this invokes all the other more
20# detailed tests in order. This script can either be called by `make
21# check' or `make installcheck'. `check' runs against the copies of
22# the program and other files in the build directory, and
23# `installcheck' against the installed copy of the program.
24
25# In either case we need to also be able to find the source directory,
26# since we read test scripts and possibly other information from
27# there.
28
29# Whenever possible, informational messages are written to stdout and
30# error messages to stderr. They're separated out by the build farm
31# display scripts.
32
33# According to the GNU autoconf manual, the only valid place to set up
34# directory locations is through Make, since users are allowed to (try
35# to) change their mind on the Make command line. So, Make has to
36# pass in all the values we need.
37
38# For other configured settings we read ./config.sh, which tells us
39# about shell commands on this machine and similar things.
40
41# rsync_bin gives the location of the rsync binary. This is either
42# builddir/rsync if we're testing an uninstalled copy, or
43# install_prefix/bin/rsync if we're testing an installed copy. On the
44# build farm rsync will be installed, but into a scratch /usr.
45
46# srcdir gives the location of the source tree, which lets us find the
47# build scripts. At the moment we assume we are invoked from the
48# source directory.
49
50# This script must be invoked from the build directory.
51
4b24f4a2
WD
52# A scratch directory, 'testtmp', is used in the build directory to
53# hold per-test subdirectories.
e7d29902 54
3a4c683f
MP
55# This script also uses the $loglevel environment variable. 1 is the
56# default value, and 10 the most verbose. You can set this from the
57# Make command line. It's also set by the build farm to give more
58# detail for failing builds.
59
60
61# NOTES FOR TEST CASES:
62
63# Each test case runs in its own shell.
e7d29902 64
12b9c840 65# Exit codes from tests:
e7d29902
MP
66
67# 1 tests failed
68# 2 error in starting tests
3a4c683f
MP
69# 77 this test skipped (random value unlikely to happen by chance, same as
70# automake)
71
12b9c840
MP
72# HOWEVER, the overall exit code to the farm is different: we return
73# the *number of tests that failed*, so that it will show up nicely in
74# the overall summary.
75
3a4c683f
MP
76# rsync.fns contains some general setup functions and definitions.
77
78
79# NOTES ON PORTABILITY:
80
81# Both this script and the Makefile have to be pretty conservative
82# about which Unix features they use.
83
84# We cannot count on Make exporting variables to commands, unless
85# they're explicitly given on the command line.
86
87# Also, we can't count on 'cp -a' or 'mkdir -p', although they're
c53b6fd0 88# pretty handy (see function makepath for the latter).
3a4c683f 89
d286ee98
MP
90# I think some of the GNU documentation suggests that we shouldn't
91# rely on shell functions. However, the Bash manual seems to say that
92# they're in POSIX 1003.2, and since the build farm relies on them
93# they're probably working on most machines we really care about.
e7d29902 94
4a7cb3e8
MP
95# You cannot use "function foo {" syntax, but must instead say "foo()
96# {", or it breaks on FreeBSD.
97
571a4b26
MP
98# BSD machines tend not to have "head" or "seq".
99
6cd7888e
MP
100# You cannot do "export VAR=VALUE" all on one line; the export must be
101# separate from the assignment. (SCO SysV)
102
c53b6fd0
WD
103# Don't rely on grep -q, as that doesn't work everywhere -- just redirect
104# stdout to /dev/null to keep it quiet.
e7d29902 105
c36b5017
MP
106
107# STILL TO DO:
108
109# We need a good protection against tests that hang indefinitely.
110# Perhaps some combination of starting them in the background, wait,
111# and kill?
112
113# Perhaps we need a common way to cleanup tests. At the moment just
114# clobbering the directory when we're done should be enough.
115
f7ca98bd
MP
116# If any of the targets fail, then (GNU?) Make returns 2, instead of
117# the return code from the failing command. This is fine, but it
118# means that the build farm just shows "2" for failed tests, not the
119# number of tests that actually failed. For more details we might
120# need to grovel through the log files to find a line saying how many
121# failed.
122
c36b5017 123
e7d29902
MP
124set -e
125
126. "./shconfig"
127
3a4c683f 128RUNSHFLAGS='-e'
23deb0bc 129export RUNSHFLAGS
3a4c683f 130
017f22b4 131# for Solaris
30fa7724 132[ -d /usr/xpg4/bin ] && PATH="/usr/xpg4/bin/:$PATH"
017f22b4 133
30fa7724
WD
134if [ "x$loglevel" != x ] && [ "$loglevel" -gt 8 ]; then
135 if set -x; then
42e66aa2
MP
136 # If it doesn't work the first time, don't keep trying.
137 RUNSHFLAGS="$RUNSHFLAGS -x"
138 fi
3a4c683f 139fi
e7d29902 140
08889527
WD
141POSIXLY_CORRECT=1
142if test x"$TOOLDIR" = x; then
143 TOOLDIR=`pwd`
144fi
145srcdir=`dirname $0`
146if test x"$srcdir" = x -o x"$srcdir" = x.; then
147 srcdir="$TOOLDIR"
148fi
149if test x"$rsync_bin" = x; then
150 rsync_bin="$TOOLDIR/rsync"
151fi
152
153# This allows the user to specify extra rsync options -- use carefully!
154RSYNC="$rsync_bin $*"
155#RSYNC="valgrind $rsync_bin $*"
156
5b385336 157TLS_ARGS=''
e717fa4d 158if egrep '^#define HAVE_LUTIMES 1' config.h >/dev/null; then
5b385336
WD
159 TLS_ARGS="$TLS_ARGS -l"
160fi
e717fa4d 161if egrep '#undef CHOWN_MODIFIES_SYMLINK' config.h >/dev/null; then
5b385336
WD
162 TLS_ARGS="$TLS_ARGS -L"
163fi
164
165export POSIXLY_CORRECT TOOLDIR srcdir RSYNC TLS_ARGS
08889527 166
e7d29902 167echo "============================================================"
08889527
WD
168echo "$0 running in $TOOLDIR"
169echo " rsync_bin=$RSYNC"
e7d29902 170echo " srcdir=$srcdir"
5b385336 171echo " TLS_ARGS=$TLS_ARGS"
e7d29902 172
30fa7724 173if [ -f /usr/bin/whoami ]; then
19cb6106 174 testuser=`/usr/bin/whoami`
30fa7724 175elif [ -f /usr/ucb/whoami ]; then
19cb6106 176 testuser=`/usr/ucb/whoami`
13d00101
WD
177elif [ -f /bin/whoami ]; then
178 testuser=`/bin/whoami`
19cb6106 179else
13d00101 180 testuser=`id -un 2>/dev/null || echo ${LOGNAME:-${USERNAME:-${USER:-'UNKNOWN'}}}`
19cb6106 181fi
53e1f937
MP
182
183echo " testuser=$testuser"
184echo " os=`uname -a`"
185
d1239eae 186# It must be "yes", not just nonnull
30fa7724 187if [ "x$preserve_scratch" = xyes ]; then
d1239eae
MP
188 echo " preserve_scratch=yes"
189else
190 echo " preserve_scratch=no"
191fi
192
f87fb190
WD
193# Check if setacl/setfacl is around and if it supports the -k or -s option.
194if setacl -k u::7,g::5,o:5 testsuite 2>/dev/null; then
195 setfacl_nodef='setacl -k'
196elif setfacl --help 2>&1 | grep ' -k,\|\[-[a-z]*k' >/dev/null; then
fa65989a
WD
197 setfacl_nodef='setfacl -k'
198elif setfacl -s u::7,g::5,o:5 testsuite 2>/dev/null; then
199 setfacl_nodef='setfacl -s u::7,g::5,o:5'
a5df33bb 200else
f87fb190 201 # The "true" command runs successfully, but does nothing.
fa65989a 202 setfacl_nodef=true
a5df33bb 203fi
d1239eae 204
08889527
WD
205export setfacl_nodef
206
30fa7724 207if [ ! -f "$rsync_bin" ]; then
e7d29902
MP
208 echo "rsync_bin $rsync_bin is not a file" >&2
209 exit 2
210fi
211
30fa7724 212if [ ! -d "$srcdir" ]; then
e7d29902
MP
213 echo "srcdir $srcdir is not a directory" >&2
214 exit 2
215fi
216
e7d29902
MP
217skipped=0
218missing=0
219passed=0
220failed=0
221
4b24f4a2
WD
222# Directory that holds the other test subdirs. We create separate dirs
223# inside for each test case, so that they can be left behind in case of
224# failure to aid investigation. We don't remove the testtmp subdir at
225# the end so that it can be configured as a symlink to a filesystem that
226# has ACLs and xattr support enabled (if desired).
08889527 227scratchbase="$TOOLDIR"/testtmp
cf72f204 228echo " scratchbase=$scratchbase"
4b24f4a2 229[ -d "$scratchbase" ] || mkdir "$scratchbase"
78ffe478 230
e7d29902
MP
231suitedir="$srcdir/testsuite"
232
3a4c683f
MP
233export scratchdir suitedir
234
cf72f204 235prep_scratch() {
dfcb3865 236 [ -d "$scratchdir" ] && chmod -R u+rwX "$scratchdir" && rm -rf "$scratchdir"
b214eda4 237 mkdir "$scratchdir"
a5df33bb 238 # Get rid of default ACLs and dir-setgid to avoid confusing some tests.
556e03a3 239 $setfacl_nodef "$scratchdir" || true
a5df33bb 240 chmod g-s "$scratchdir"
928da423
WD
241 case "$srcdir" in
242 /*) ln -s "$srcdir" "$scratchdir/src" ;;
243 *) ln -s "$TOOLDIR/$srcdir" "$scratchdir/src" ;;
244 esac
cf72f204
MP
245 return 0
246}
247
c019068f
MP
248maybe_discard_scratch() {
249 [ x"$preserve_scratch" != xyes ] && [ -d "$scratchdir" ] && rm -rf "$scratchdir"
cf72f204 250 return 0
b214eda4
MP
251}
252
30fa7724 253if [ "x$whichtests" = x ]; then
c36b5017
MP
254 whichtests="*.test"
255fi
256
257for testscript in $suitedir/$whichtests
e7d29902 258do
89a9c054 259 testbase=`echo $testscript | sed -e 's!.*/!!' -e 's/.test\$//'`
4b24f4a2 260 scratchdir="$scratchbase/$testbase"
e7d29902 261
cf72f204 262 prep_scratch
e7d29902 263
cf72f204
MP
264 set +e
265 sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1
266 result=$?
267 set -e
268
c019068f
MP
269 if [ "x$always_log" = xyes -o \( $result != 0 -a $result != 77 -a $result != 78 \) ]
270 then
271 echo "----- $testbase log follows"
272 cat "$scratchdir/test.log"
273 echo "----- $testbase log ends"
53adbd7a
WD
274 if [ -f "$scratchdir/rsyncd.log" ]; then
275 echo "----- $testbase rsyncd.log follows"
276 cat "$scratchdir/rsyncd.log"
277 echo "----- $testbase rsyncd.log ends"
278 fi
c019068f
MP
279 fi
280
cf72f204
MP
281 case $result in
282 0)
f08aacf7 283 echo "PASS $testbase"
e7d29902 284 passed=`expr $passed + 1`
c019068f 285 maybe_discard_scratch
cf72f204
MP
286 ;;
287 77)
7d821932 288 # backticks will fill the whole file onto one line, which is a feature
1657be22
WD
289 whyskipped=`cat "$scratchdir/whyskipped"`
290 echo "SKIP $testbase ($whyskipped)"
cf72f204 291 skipped=`expr $skipped + 1`
c019068f 292 maybe_discard_scratch
cf72f204 293 ;;
be2f866b
MP
294 78)
295 # It failed, but we expected that. don't dump out error logs,
296 # because most users won't want to see them. But do leave
297 # the working directory around.
298 echo "XFAIL $testbase"
299 failed=`expr $failed + 1`
300 ;;
cf72f204 301 *)
f08aacf7 302 echo "FAIL $testbase"
cf72f204 303 failed=`expr $failed + 1`
30fa7724 304 if [ "x$nopersist" = xyes ]; then
cf72f204
MP
305 exit 1
306 fi
307 esac
e7d29902
MP
308done
309
310echo '------------------------------------------------------------'
311echo "----- overall results:"
312echo " $passed passed"
ec99e9da
MP
313[ "$failed" -gt 0 ] && echo " $failed failed"
314[ "$skipped" -gt 0 ] && echo " $skipped skipped"
315[ "$missing" -gt 0 ] && echo " $missing missing"
e7d29902
MP
316echo '------------------------------------------------------------'
317
32c58f06
MP
318# OK, so expr exits with 0 if the result is neither null nor zero; and
319# 1 if the expression is null or zero. This is the opposite of what
320# we want, and if we just call expr then this script will always fail,
321# because -e is set.
322
32c58f06
MP
323result=`expr $failed + $missing || true`
324echo "overall result is $result"
d2476f0d 325exit $result